; nested loop example from slide

(declare-rel inv1 (Int))
(declare-rel inv2 (Int Int))
(declare-var x0 Int)
(declare-var x1 Int)
(declare-var y0 Int)
(declare-var y1 Int)
(declare-rel fail ())

; expected to be SAT

(rule (=> (= x1 0) (inv1 x1)))

(rule (=> (and (inv1 x0) (= y1 0)) (inv2 x0 y1)))

; fill in inductiveness rule for inner loop
(rule (=> (and (inv2 x0 y0) (= y1 (+ y0 1))) (inv2 x? y?)))

; fill in rule for update in outer loop after inner loop
(rule (=> (and (inv2 x0 y0) (= x1 (+ ?? ??))) (inv1 x1)))

; change the assertion in rule below so that program is not safe
(rule (=> (and (inv1 x0) (not (>= x0 0))) fail))

(query fail)
